// #name = DroppedTimer
// #version = 1.1
// #date = 4th April 2001
// #author = Crunchy
// #email = crunchy@barrysworld.com
// #web = http://guides.barrysworld.com/tribes/scripts/
// #description = Adds a dropped flag timer to objectiveHUD.
// #status = final

//
// --- Main Code ---
//

// START package DroppedTimer
package DroppedTimer {


function DroppedTimerLoop(%index)
{
	if ($DroppedTimer[%index])
	{
		%time = 45-mFloor((getSimTime()-$DroppedTimerStart[%index])/1000);
		
		// Add extra check of score going negative
		if (%time >= 0)
		{	
			objectiveHud.flagLocation[%index].setValue("<Dropped: "@%time@">");
			schedule(300, 0, DroppedTimerLoop, %index);
		}
	}
}

function DroppedTimer(%index)
{
	$DroppedTimerStart[%index] = getSimTime();
	$DroppedTimer[%index] = true;
	objectiveHud.flagLocation[%index].setValue("<Dropped: 45>");
	
	schedule(300, 0, DroppedTimerLoop, %index);
}

function DroppedTimerCancel(%index)
{
	$DroppedTimer[%index] = false;
}

function DroppedTimerReset()
{
	deleteVariables("$DroppedTimer*");
}

//
// --- Objective HUD overrides ---
//

function ctfFlagDropped(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
	%index = detag(%a3);

	DroppedTimer(%index);
}

function ctfFlagTaken(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
	%index = detag(%a3);
	%taker = detag(%a4);

	DroppedTimerCancel(%index);
	objectiveHud.flagLocation[%index].setValue(%taker);
}	   

function ctfFlagReturned(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
	DroppedTimerCancel(detag(%a3));

	%index = detag(%a3);

	DroppedTimerCancel(%index);
	objectiveHud.flagLocation[%index].setValue("<At Base>");
}

//
// --- Overrides ---
//

function DispatchLaunchMode()
{
	addMessageCallback('MsgClearObjHud', DroppedTimerReset);

	parent::DispatchLaunchMode();
}


}; // END package DroppedTimer
activatePackage(DroppedTimer);
